{
    "$graph": [
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "python",
                "-m",
                "ochre.ocrevaluation_extract"
            ],
            "requirements": [
                {
                    "envDef": [
                        {
                            "envValue": "C.UTF-8",
                            "envName": "LANG"
                        },
                        {
                            "envValue": "C.UTF-8",
                            "envName": "LC_ALL"
                        }
                    ],
                    "class": "EnvVarRequirement"
                }
            ],
            "inputs": [
                {
                    "type": "File",
                    "inputBinding": {
                        "position": 1
                    },
                    "id": "#ocrevaluation-extract.cwl/in_file"
                }
            ],
            "id": "#ocrevaluation-extract.cwl",
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*-character.csv"
                    },
                    "id": "#ocrevaluation-extract.cwl/character_data"
                },
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "*-global.csv"
                    },
                    "id": "#ocrevaluation-extract.cwl/global_data"
                }
            ]
        },
        {
            "class": "Workflow",
            "inputs": [
                {
                    "type": "File",
                    "id": "#main/gt"
                },
                {
                    "type": "File",
                    "id": "#main/ocr"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "id": "#main/xmx"
                }
            ],
            "outputs": [
                {
                    "outputSource": "#main/ocrevaluation-extract/character_data",
                    "type": "File",
                    "id": "#main/character_data"
                },
                {
                    "outputSource": "#main/ocrevaluation-extract/global_data",
                    "type": "File",
                    "id": "#main/global_data"
                }
            ],
            "steps": [
                {
                    "run": "#ocrevaluation.cwl",
                    "in": [
                        {
                            "source": "#main/gt",
                            "id": "#main/ocrevaluation/gt"
                        },
                        {
                            "source": "#main/ocr",
                            "id": "#main/ocrevaluation/ocr"
                        },
                        {
                            "source": "#main/xmx",
                            "id": "#main/ocrevaluation/xmx"
                        }
                    ],
                    "out": [
                        "#main/ocrevaluation/out_file"
                    ],
                    "id": "#main/ocrevaluation"
                },
                {
                    "run": "#ocrevaluation-extract.cwl",
                    "in": [
                        {
                            "source": "#main/ocrevaluation/out_file",
                            "id": "#main/ocrevaluation-extract/in_file"
                        }
                    ],
                    "out": [
                        "#main/ocrevaluation-extract/character_data",
                        "#main/ocrevaluation-extract/global_data"
                    ],
                    "id": "#main/ocrevaluation-extract"
                }
            ],
            "id": "#main"
        },
        {
            "class": "CommandLineTool",
            "baseCommand": [
                "java",
                "-cp",
                "/ocrevalUAtion/target/ocrevaluation.jar"
            ],
            "requirements": [
                {
                    "class": "DockerRequirement",
                    "dockerPull": "nlppln/ocrevaluation-docker"
                },
                {
                    "class": "InitialWorkDirRequirement",
                    "listing": [
                        {
                            "entryname": "$(inputs.gt.nameroot)_out.html",
                            "writable": true,
                            "entry": "<h2>General results</h2>\n<table border=\"1\">\n<tr>\n<td>CER</td><td>n/a</td>\n</tr>\n<tr>\n<td>WER</td><td>n/a</td>\n</tr>\n<tr>\n<td>WER (order independent)</td><td>n/a</td>\n</tr>\n</table>\n<h2>Difference spotting</h2>\n<table border=\"1\">\n</table>\n<h2>Error rate per character and type</h2>\n<table border=\"1\">\n<tr>\n<td>Character</td><td>Hex code</td><td>Total</td><td>Spurious</td><td>Confused</td><td>Lost</td><td>Error rate</td>\n</tr>\n<tr>\n<td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td><td>n/a</td>\n</tr>\n</table>\n"
                        }
                    ]
                }
            ],
            "arguments": [
                {
                    "prefix": "-o",
                    "valueFrom": "$(runtime.outdir)/$(inputs.gt.nameroot)_out.html",
                    "position": 4
                },
                {
                    "valueFrom": "eu.digitisation.Main",
                    "position": 1
                }
            ],
            "successCodes": [
                1
            ],
            "inputs": [
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "inputBinding": {
                        "prefix": "-e",
                        "position": 5
                    },
                    "id": "#ocrevaluation.cwl/encoding"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-gt",
                        "position": 2
                    },
                    "id": "#ocrevaluation.cwl/gt"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "-ic",
                        "position": 6
                    },
                    "id": "#ocrevaluation.cwl/ignore_case"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "-id",
                        "position": 7
                    },
                    "id": "#ocrevaluation.cwl/ignore_diacritics"
                },
                {
                    "type": [
                        "null",
                        "boolean"
                    ],
                    "inputBinding": {
                        "prefix": "-ip",
                        "position": 8
                    },
                    "id": "#ocrevaluation.cwl/ignore_punctuation"
                },
                {
                    "type": "File",
                    "inputBinding": {
                        "prefix": "-ocr",
                        "position": 3
                    },
                    "id": "#ocrevaluation.cwl/ocr"
                },
                {
                    "type": [
                        "null",
                        "string"
                    ],
                    "default": "5G",
                    "inputBinding": {
                        "prefix": "-Xmx",
                        "separate": false,
                        "position": 0
                    },
                    "id": "#ocrevaluation.cwl/xmx"
                }
            ],
            "outputs": [
                {
                    "type": "File",
                    "outputBinding": {
                        "glob": "$(inputs.gt.nameroot)_out.html"
                    },
                    "id": "#ocrevaluation.cwl/out_file"
                }
            ],
            "id": "#ocrevaluation.cwl"
        }
    ],
    "cwlVersion": "v1.0"
}
